﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Text;

using HeuristicLab.Services.Authentication.DataAccess;
using HeuristicLab.Services.Authentication.DataTransfer;
using HeuristicLab.Services.Authentication;
using DA = HeuristicLab.Services.Authentication.DataAccess;
using DT = HeuristicLab.Services.Authentication.DataTransfer;
using HLSA = HeuristicLab.Services.Authentication;

namespace HeuristicLab.Services.Authentication.AdminMethods {
  class AdminMethods {

    public static bool InsertClient(string name, string description, string resourceType, string processorType,
      int numberOfProcessors, int numberOfThreads, string ipAdresse, int memorySize, string operatingSystem) {      
      DT.Client c = new DT.Client();
      c.ResourceID = Guid.NewGuid();
      c.Name = name;      
      c.Description = description;
      //c.ResourceType = resourceType;
      c.ProcessorType = processorType;
      c.NumberOfProcessors = numberOfProcessors;
      c.NumberOfThreads = numberOfThreads;
      c.MemorySize = memorySize;      
      c.IPAdresse = ipAdresse;
      using (ClientManagmentDataContext cmdc = new ClientManagmentDataContext()) {
        if (cmdc.DatabaseExists()) {
          DA.Client clEntity = HLSA.Convert.ToEntity(c);
          cmdc.GetTable<DA.Resource>().InsertOnSubmit(clEntity);
          cmdc.SubmitChanges();
          return true;
        }
        return false;
      }   
    }

    public static bool InsertGroup(string name, string description, string resourceType) {
      DT.ResourceGroup g = new DT.ResourceGroup();
      g.ResourceID = Guid.NewGuid();
      g.Name = name;
      g.Description = description;
      //g.ResourceType = resourceType;
      using (ClientManagmentDataContext cmdc = new ClientManagmentDataContext()) {
        if (cmdc.DatabaseExists()) {
          DA.ResourceGroup gEntity = HLSA.Convert.ToEntity(g);
          cmdc.GetTable<DA.Resource>().InsertOnSubmit(gEntity);
          cmdc.SubmitChanges();
          return true;
        }
        return false;
      }
    }

    public static bool UpdateClient(string name, string description, string resourceType, string processorType,
      int numberOfProcessors, int numberOfThreads, string ipAdresse, int memorySize, string operatingSystem) {
      
      DT.Client uc = new DT.Client();
      uc.Name = name;
      uc.Description = description;
      //uc.ResourceType = resourceType;
      uc.ProcessorType = processorType;
      uc.NumberOfProcessors = numberOfProcessors;
      uc.NumberOfThreads = numberOfThreads;
      uc.MemorySize = memorySize;
      uc.IPAdresse = ipAdresse;

      using (ClientManagmentDataContext cmdc = new ClientManagmentDataContext()) {
        if (cmdc.DatabaseExists()) {
          DA.Resource entity = cmdc.GetTable<DA.Resource>().FirstOrDefault(x => x.Name == uc.Name);
          if (entity != null) {
            uc.ResourceID = entity.ResourceID;
            uc.ResourceType = entity.ResourceType;
            HLSA.Convert.ToEntity(uc, (DA.Client)entity);
            cmdc.SubmitChanges();
            return true;
          }
        }
      }
      return false;
    }

    public static string DeleteResource(string name) {
      using (ClientManagmentDataContext cmdc = new ClientManagmentDataContext()) {
        string data = "deleted nothing";
        if (cmdc.DatabaseExists()) {
          DA.Resource entity = cmdc.GetTable<DA.Resource>().FirstOrDefault(x => x.Name == name);
          if (entity != null) {            
            if (entity.ResourceType == "Client") {
              data = "deleted: ";
              data += (HLSA.Convert.ToDto((DA.Client)entity)).ToString();
              cmdc.GetTable<DA.Resource>().DeleteOnSubmit(entity);
            }
            else if (entity.ResourceType == "ResourceGroup") {
              data = "deleted: ";
              data += (HLSA.Convert.ToDto((DA.ResourceGroup)entity)).ToString();
              cmdc.GetTable<DA.Resource>().DeleteOnSubmit(entity);
            }
            else return data;
            cmdc.SubmitChanges();
          }
        }
        return data;
      }
    }



  }
}
